// this is a placeholder for the breadth-first search of the Graph
import java.util.*;

public final class ShortestPath{
	
	// need to make this return a list later!!
	public static final LinkedList getShortestPath(BoardGraph g, BoardNode start, BoardNode destination){
		if(start.equals(destination)){
			LinkedList ans = new LinkedList();
			ans.add(destination);
			return ans;
		}
		int s = g.getList().indexOf(start);
		int v = g.getList().indexOf(destination);
		Iterator it = g.getList().iterator();
		while(it.hasNext()){
			BoardNode n = (BoardNode)it.next();
			n.color = BoardNode.WHITE;
			n.dist = Integer.MAX_VALUE;
			n.pred = -1;
		}
		((BoardNode)g.getList().get(s)).color = BoardNode.GREY;
		((BoardNode)g.getList().get(s)).dist = 0;
		
		Queue Q = new Queue();
		Q.enqueue(new Integer(s));
		int u;
		boolean found = false;
		while(!found && !Q.isEmpty()){
			u = ((Integer)Q.head()).intValue();
			BoardNode n = (BoardNode)g.getList().get(u);
			found = found || doAdjacents(n, n.getNorth(), destination, Q, u, g.getList().indexOf(n.getNorth()));
			found = found || doAdjacents(n, n.getSouth(), destination, Q, u, g.getList().indexOf(n.getSouth()));
			found = found || doAdjacents(n, n.getEast(), destination, Q, u, g.getList().indexOf(n.getEast()));
			found = found || doAdjacents(n, n.getWest(), destination, Q, u, g.getList().indexOf(n.getWest()));
			//
			Q.dequeue();
			n.color=BoardNode.BLACK;
		}
		if(found){
			LinkedList l = new LinkedList();
			l.addFirst(destination);
			while(((BoardNode)l.getFirst()).pred!=-1){
				l.addFirst(g.getList().get(((BoardNode)l.getFirst()).pred));
			}
			return l;
		}else
			return null;
	}
	
	
	private static final boolean doAdjacents(BoardNode u, BoardNode v, BoardNode dest, Queue Q, int uu, int vv){
		if(v!=null && v.color==BoardNode.WHITE){
			v.color=BoardNode.GREY;
			v.dist = u.dist+1;
			v.pred = uu;
			Q.enqueue(new Integer(vv));
			return v.equals(dest);
		} else
			return false;
	}
	
	//public static final List getShortestPath(BoardGraph g, BoardNode s, BoardNode v){
		//
	//}
	
	/*
	// not completely sure what to return quite yet...
	public static final void breadthFirst(BoardGraph g, BoardNode start, BoardNode destination){
		int s = g.getList().indexOf(start);
		int v = g.getList().indexOf(destination);
		
		int len = g.getList().size();
		int[] color = new int[len];
		int[] pred = new int[len];
		int[] dist = new int[len];
		Arrays.fill(color, WHITE);
		Arrays.fill(pred, -1);
		Arrays.fill(dist, Integer.MAX_VALUE);
		
		color[s]=GREY;
		dist[s]=0;
		Queue Q = new Queue();
		Q.enqueue(new Integer(s));
		int u;
		int[] adj = new int[4];
		Arrays.fill(adj, -1);
		while(!Q.isEmpty()){
			u = ((Integer)Q.head()).intValue();
			
		}
	}
	
	private static final void getAdj(BoardGraph g, int u, int[] adj){
		adj[0]=g.getList().indexOf(((BoardNode)g.getList().get(u)).getNorth());
	}
	*/
	
}
