import java.util.*;

public class PackageTable extends HashMap{
	
	public void addLocation(BoardNode n){
		if(!containsKey(n)){
			put(n, new ArrayList());
		}
	}
	
	/*
	public ArrayList getPackages(BoardNode location){
		//return ((ArrayList)get(location));
		ArrayList ans = ((ArrayList)get(location));
		if(ans==null)
			return new ArrayList();
		else
			return ans;
	}
	*/
	
	public ArrayList getPackages(BoardNode location){
		if(containsKey(location)){
			return (ArrayList)get(location);
		}else{
			return new ArrayList();
		}
	}
	
	
	public void addPackage(ThePackage pkg){
		addPackage(pkg, pkg.getDestination());
	}
	
	// this way i can make a table based on destination, and on current board
	// location
	public void addPackage(ThePackage pkg, BoardNode key){
		addLocation(key);
		ArrayList ll = getPackages(key);
		ll.add(pkg);
	}
	
	public void rem(ThePackage pkg, BoardNode key){
		getPackages(key).remove(pkg);
	}
	
}
